/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  File area routines (overlay 2)                                         *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <mem.h>
#include <errno.h>
#include <io.h>
#include <fcntl.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <ctype.h>
#include <time.h>
#include <string.h>
#include "zmodem.h"
#include "prog.h"
#include "ffind.h"
#include "alc.h"
#include "max.h"
#include "max_msg.h"
#include "arc.h"

static int near pascal Zip_Scan_For_Header(char *buffer);
static int near pascal IsValidFileArea(struct _area *a,int areanum);

void pascal File_Raw(void)
{
  FFIND *ff;
  union stamp_combo stamp;

  char temp[PATHLEN],
       string[PATHLEN],
       nonstop;

  int ret;

  if (! *linebuf)
    Display_File(0,NULL,"%sRAWDIR",area.filepath);

  WhiteN();
  
  OpusGets(temp,s(fname_mask));

  WhiteN();

  if (! *temp)  /* If user pressed Enter */
    strcpy(temp,"*.*");

  Strip_Path(temp);

  display_line=display_col=1;
  nonstop=FALSE;

  for (ff=FindOpen(temp,MSDOS_subdir),ret=0; ff && ret==0; ret=FindNext(ff))
  {
    if (display_col==1 && MoreYnBreak(&nonstop,NULL))
      break;

    stamp.dos_st.date=ff->ff_fdate;
    stamp.dos_st.time=ff->ff_ftime;

    sprintf(string,"%s %d, %d",months[stamp.msg_st.date.mo-1],
                               stamp.msg_st.date.da,
                               1980+stamp.msg_st.date.yr);

    if (ff->ff_attrib & MSDOS_subdir)
      strcpy(temp,"  <DIR>");
    else sprintf(temp,"%7ld",ff->ff_fsize);

    Printf("%-12.12s %s     %-18s %02d:%02d\n",ff->ff_name,temp,
           string,stamp.msg_st.time.hh,stamp.msg_st.time.mm);
  }

  FindClose(ff);
}

/* Add an uploaded filename's filename/description to FILES.BBS */

void pascal Get_File_Description(char *filename,long fsize,char *dsc)
{
  struct tm *stim;
  long curt;

  FILE *bbsfile;

  char temp[PATHLEN],
       description[PATHLEN],
       nw[PATHLEN],
       *p;

  int desc_num,
      wrapped;

  if (local || carrier())
  {
    if (*area.filesbbs)
      strcpy(temp,area.filesbbs);
    else sprintf(temp,ss,area.uppath,files_bbs);

    if ((bbsfile=shfopen(temp,fopen_append,O_WRONLY | O_APPEND))==NULL)
      logit(cantopen,temp);
    else
    {
      desc_num=1;

      curt=time(NULL);
      stim=localtime(&curt);

      if (!(dsc && *dsc) && (local || carrier()))
        Printf(s(desc_many),strupr(filename));

      /* Display a maximum-length bar */

      if (! (dsc && *dsc) && (local || carrier()))
        Puts(LGREEN "\n  \x19\x2d\n");
      
      *nw='\0';

      while (desc_num <= 3)
      {
        sprintf(temp,GRAY "%d> " YELLOW,desc_num);

        *description='\0';

        while (isblstr(description))
        {
          if (dsc && *dsc)
            strcpy(description,dsc);
          else
          {
            if (local || carrier())
            {
              if (*nw)
                strcpy(description,nw);
              else *description='\0';

              wrapped=Input(description,INPUT_nlb_line | INPUT_nohotflash |
                    INPUT_wordwrap,0,45,temp);
                  
              if (wrapped==1)
                strcpy(nw,description+strlen(description)+1);
              else *nw='\0';

            }
            else *description='\0';
          }

          if (! *description && desc_num != 1)
            break;
          
          if (! *nw)
            strcat(description," ");
        }

        if (! *description)
          break;

        /* Only add date directly to FILES.BBS unless it's being supposed to *
         * be determined automagically.                                      */

        if (! (prm.flags & FLAG_autodate))
        {
          sprintf(temp,"%7ld ",fsize);

          switch (prm.date_style)
          {
            case -1:  /* None, so give neither dates nor sizes */
              *temp='\0';
              break;

            case 0: /* MM-DD-YY */
              sprintf(&temp[strlen(temp)],s(date_str),
                      stim->tm_mon+1,stim->tm_mday,stim->tm_year);
              break;

            case 1: /* DD-MM-YY */
              sprintf(&temp[strlen(temp)],s(date_str),
                      stim->tm_mday,stim->tm_mon+1,stim->tm_year);
              break;

            case 2: /* YY-MM-DD */
              sprintf(&temp[strlen(temp)],s(date_str),
                      stim->tm_year,stim->tm_mon+1,stim->tm_mday);
              break;

            case 3: /* YYMMDD */
              sprintf(&temp[strlen(temp)],s(datestr),
                      stim->tm_year,stim->tm_mon+1,stim->tm_mday);
              break;
          }

          if (prm.date_style != -1)
            strcat(temp," ");
        }
        else *temp='\0';

        for (p=description;*p;p++)
          if (*p < 32)
            *p=' ';

        for (p=filename;*p;p++)
          if (*p < 32)
            *p='\0';

        if (desc_num++==1)
          fprintf(bbsfile,"%-12s %s%s",filename,temp,description);
        else fputs(description,bbsfile);

        if ((! carrier() && !local) || (dsc && *dsc))
          break;
      }
      
      fputc('\n',bbsfile);
      fclose(bbsfile);
    }
  }
}



char * pascal Remove_Files_Entry(char *filename,char *description)
{
  int x;

  FILE *infilesbbs,
       *outfilesbbs;

  char temp[255],
       poo_name[PATHLEN],
       *fbbs;

  x=strlen(filename);
  strupr(filename);
  
  if (description)
    *description='\0';

  if ((infilesbbs=shfopen(fbbs=(*area.filesbbs ? area.filesbbs : files_bbs),
                        fopen_read,O_RDONLY))==NULL)
  {
    Printf(&cantopen[1],fbbs);
    logit(cantopen,fbbs);
    return NULL;
  }

  sprintf(poo_name,files_poo,PRM(temppath),task_num);

  if ((outfilesbbs=shfopen(poo_name,fopen_write,O_WRONLY | O_TRUNC | O_CREAT))==NULL)
  {
    Printf(&cantopen[1],poo_name);
    logit(cantopen,poo_name);
    return NULL;
  }

  while (1)
  {
    if (fgets(temp,sizeof(temp),infilesbbs)==NULL)
      break;

    /* If this is the file... */
    
    if (strnicmp(temp,filename,x)==0 &&
        (temp[x]==' ' || temp[x]=='\n' || temp[x]=='\t'))
    {
      if (description)
        strcpy(description,temp); /* Return the file entry, maybe for H)url? */
    }
    else
    {
      if (fputs(temp,outfilesbbs)==EOF)
      {
        Printf(s(err_writ),poo_name);
        return NULL;
      }
    }
  }

  fclose(infilesbbs);
  fclose(outfilesbbs);

  /* Delete the backup file, if any */
  if (fexist(files_bak))
    unlink(files_bak);

  /* Save the original file in case we screwed up...  (But don't do so     *
   * if we have an explicit FILES.BBS path, since we might be running      *
   * on a WORM, and we don't want to write to it in that case.)            */

  if (! *area.filesbbs)
    move_file(fbbs,files_bak);
  else unlink(fbbs);

  /* And put the new one in its place! */
  move_file(poo_name,fbbs);

  if (description && *description)
    return description;   /* Return entry of deleted file */
  else return NULL;
}


void pascal File_Hurl(void)
{
  struct _area ar;

  FILE *outfilesbbs;

  int an;

  char temp[255],
       temp2[PATHLEN],
       filename[PATHLEN],
       *p;

  WhiteN();

  OpusGets(filename,s(hurl_what));

  if (*filename)
  {
    Strip_Path(filename); /* Make sure user doesn't specify path or device */

    if (! *filename || ! File_Okay(filename))
      return;

    for (strcpy(temp,qmark);eqstri(temp,qmark);)
    {
      OpusGets(temp,s(area_to_hurl));

      if (eqstri(temp,qmark))
        List_File_Areas();
    }
    
    if (! *temp)
      return;

    Read_Area(&ar,an=Set_Area_Name(temp));

    if (IsValidFileArea(&ar,an))
    {
      if (*ar.filesbbs)
        strcpy(temp,ar.filesbbs);
      else sprintf(temp,ss,ar.filepath,files_bbs);

      if ((outfilesbbs=shfopen(temp,fopen_append,O_WRONLY | O_APPEND)) != NULL)
      {
        /* Now move the actual file... */
        sprintf(temp,ss,area.filepath,filename);
        sprintf(temp2,ss,ar.filepath,filename);

        Printf(hurling,temp,temp2);

        if (move_file(temp,temp2)==-1)
        {
          logit(cantopen,temp2);

          Putc('\n');
          Printf(&cantopen[1],temp2);
          Press_ENTER();
        }
        else
        {
          /* Remove it from OUR files.bbs... */

          p=Remove_Files_Entry(filename,temp);

          /* ...and put it in theirs. */

          if (p)
            fputs(p,outfilesbbs);
          else fprintf(outfilesbbs,"%s\n",strupr(filename));

          Puts(done);
        }

        fclose(outfilesbbs);
      }
      else
      {
        logit(cantopen,temp);
        Printf(&cantopen[1],temp);
      }
    }
    else
    {
      if (*PRM(areanotexist))
        Display_File(0,NULL,PRM(areanotexist));
      else
      {
        Puts(areadoesntexist);
        Press_ENTER();
      }
    }
  }
}

void pascal File_Override_Path(void)
{
  char temp[PATHLEN];

  WhiteN();

  OpusGets(temp,s(full_ovr_path));

  if (*temp)
  {
    if (!direxist(temp))
    {
      Printf(cantfind,temp);
      return;
    }

    if (*temp && temp[strlen(temp)-1] != '\\')
      strcat(temp,"\\");

    strcpy(area.filepath,temp);
    strcpy(area.uppath,temp);
    strcpy(area.fileinfo,temp);

    Save_Directory(temp);
  }
}

int pascal Get_New_Date(union stamp_combo *new_date,union stamp_combo *laston)
{
  char temp[PATHLEN],
       prompt[PATHLEN],
       *scanfmt;

  int mm,dd,yy,
      *a1,*a2,*a3;

  WhiteN();

  strcpy(prompt,s(dtsf));
  scanfmt=s(scan_str);

  switch (prm.date_style)
  {
    /* Even if no default date style, we need to display something, so      *
     * use USA format.                                                      */

    default:
    case -1: 
    case 0:
      sprintf(&prompt[strlen(prompt)],s(date_str),
              laston->msg_st.date.mo,laston->msg_st.date.da,
              laston->msg_st.date.yr+80);

      a1=&mm; a2=&dd; a3=&yy;
      break;

    case 1:
      sprintf(&prompt[strlen(prompt)],s(date_str),
              laston->msg_st.date.da,laston->msg_st.date.mo,
              laston->msg_st.date.yr+80);

      a1=&dd; a2=&mm; a3=&yy;
      break;

    case 2:
      sprintf(&prompt[strlen(prompt)],s(date_str),
              laston->msg_st.date.yr+80,laston->msg_st.date.mo,
              laston->msg_st.date.da);

      a1=&yy; a2=&mm; a3=&dd;
      break;

    case 3:
      sprintf(&prompt[strlen(prompt)],s(datestr),
              laston->msg_st.date.yr+80,laston->msg_st.date.mo,
              laston->msg_st.date.da);

      a1=&yy; a2=&mm; a3=&dd;
      scanfmt=s(datestr);
      break;
  }

  strcat(prompt,": ");

  OpusGets(temp,prompt);

  WhiteN();

  if (! *temp)
  {
    mm=laston->msg_st.date.mo;
    dd=laston->msg_st.date.da;
    yy=laston->msg_st.date.yr+80;
  }

  if (! ((! *temp || sscanf(temp,scanfmt,a1,a2,a3)==3) && mm >= 1 &&
      mm <= 12 && dd >= 1 && dd <= 31 && yy >= 80))
  {
    Puts(s(bad_date));
    return -1;
  }

  new_date->msg_st.date.mo=mm;
  new_date->msg_st.date.da=dd;
  new_date->msg_st.date.yr=yy-80;
  new_date->msg_st.time.hh=0;
  new_date->msg_st.time.mm=0;
  new_date->msg_st.time.ss=0;

  return 0;
}


void pascal File_Get_Files(int protocol,char *mname)
{
  FILE *xferinfo;

  FFIND *ff;

  char cmd[PATHLEN],
       temp[PATHLEN],
       temp2[PATHLEN],
       ulpath[PATHLEN],
       save_tc,
       batch,
       *filename,
       *p;

  long ul_start_time,
       temp_long;

  int x;


  if ((protocol >= 0 && !(prm.protoflag[protocol] & XTERNBATCH)) ||
      protocol==PROTOCOL_xmodem || protocol==PROTOCOL_xmodem1k)
    batch=FALSE;
  else batch=TRUE;

  strcpy(ulpath,area.uppath);

  Printf(s(mode_bg),Protocol_Name(protocol,temp));

  if (protocol==PROTOCOL_xmodem || protocol==PROTOCOL_xmodem1k)
    Printf("%s ",strupr(filenames[0]));

  Puts(s(end_receive));

  /* Force logit() calls to be displayed on-screen */
  in_file_xfer=TRUE;

  filename=NULL;
  fnames=0;

  ul_start_time=time(NULL);

  logit(s(log_getting_from),usr.name,baud);

  /* Turn off ^S/^Q flow control and ^C/^K checking, so it doesn't
     screw up the transfers!                                       */

  Open_OpusXfer(&xferinfo);

  Mdm_flush();
  Mdm_Flow_Off();

  ul_no_space=FALSE;

  if ((Txbuf=Secbuf=zalloc()) != NULL)
  {
    switch (protocol)
    {
      case PROTOCOL_zmodem:
        get_Zmodem(ulpath,xferinfo);
        break;

      case PROTOCOL_xmodem:
      case PROTOCOL_xmodem1k:
      case PROTOCOL_telink:
      case PROTOCOL_sealink:
        switch (protocol)
        {
          case PROTOCOL_xmodem:
            protocol_letter='X';
            break;

          case PROTOCOL_xmodem1k:
            protocol_letter='Y';
            break;

          case PROTOCOL_telink:
            protocol_letter='T';
            break;

          case PROTOCOL_sealink:
            protocol_letter='S';
            break;
        }

        if (protocol==PROTOCOL_sealink || protocol==PROTOCOL_telink)
        {
          x=TRUE;

          /* Filename to receive */
          strcpy(temp,filenames[0]);

          while (x)
          {
            /* Loop until we run out of files to receive! */

            if (protocol==PROTOCOL_telink)
              x=recvmdm7(temp);
            else mknl(temp);

            if (x)
            {
              x=(filename=receive_file(ulpath,temp,protocol_letter)) != NULL;

              if (filename != NULL)
              {
                strcpy(filenames[fnames++],filename);

                if (fnames==MAXEXPAND)
                  break;
              }
            }
          }
        }
        else
        {
          filename=receive_file(ulpath,filenames[0],protocol_letter);

          if (filename != NULL)
            strcpy(filenames[fnames++],filename);
        }
        break;

      default:  /* External protocol.  Remember to copy changes to above! */
        protocol_letter=*Protocol_Name(protocol,temp);

        getword(PRM(protocols[protocol]),temp,".",1);
        strcat(temp,".Ctl");
        Add_Task_Number(temp,temp2);

        if (prm.protoflag[protocol] & XTERNEXIT)
          sprintf(temp,"%d ",prm.protoexit);
        else *temp='\0';

        sprintf(cmd,xtrn_caller,temp,PRM(protocols[protocol]),temp2);

        /* Now figure out what we're supposed to be receiving, and plug it   *
         * into filesnames[] so the Outside function can get at it, and      *
         * stick it in the .CTL file...                                      */

        if (batch)
          sprintf(filenames[0],"%s*.*",ulpath);
        else
        {
          sprintf(temp,ss,ulpath,filenames[0]);
          strcpy(filenames[0],temp);
        }

        fnames=1;

        Outside(NULL,NULL,(prm.protoflag[protocol] & XTERNEXIT) ?
                OUTSIDE_errorlevel : OUTSIDE_run,cmd,FALSE,CTL_upload,
                RESTART_menu,mname);
        break;
    }

    free(Txbuf);
    Txbuf=Secbuf=NULL;
  }

  /* In case anything is left over from a file transfer... */
  mdm_dump(DUMP_input);
  Clear_KBuffer();

  /* And turn flow control back on! */
  Mdm_Flow_On();

  in_file_xfer=FALSE;

  Close_OpusXfer(&xferinfo);

  if (protocol==PROTOCOL_zmodem)  /* Parse OpusXfer log to find out what we got */
  {
    sprintf(temp,opusxfer_name,original_path,task_num);

    fnames=0;

    if ((xferinfo=shfopen(temp,fopen_read,O_RDONLY))==NULL)
      logit(cantfind,temp);
    else
    {
      while (fgets(temp,PATHLEN,xferinfo) != NULL)
      {
        Trim_Line(temp);

        /* Chop off path */
        if ((p=strrchr(temp,'\\')) != NULL || (p=strrchr(temp,'/')) != NULL)
          p++;
        else p=temp;

        if (p && ! isnl(p))
          strcpy(filenames[fnames++],p);

        if (fnames==MAXEXPAND)
          break;
      }

      fclose(xferinfo);
    }
  }

  save_tc=do_timecheck;
  do_timecheck=FALSE;

  if (ul_no_space)
    Display_File(0,NULL,PRM(no_space));

  if (protocol < 0)   /* If we were using an internal protocol -- If it    */
  {                   /* was external, the .LOG parsing routine will take  */
                      /* care of it...                                     */

    if (fnames)
    {
      /* Even if user *did* drop carrier, we want to add these to the        *
       * FILES.BBS anyway, so they don't get lost and hog the Sysop's disk   *
       * space!                                                              */

      if (carrier())
      {
        Delay(50);

        Puts(xfercomplete);

        if (last_bps && fnames)
          Printf(cps_rating,(int)(last_bps/10L),(int)(last_bps*100L/baud));
        else Putc('\n');

        if (fnames)
          Printf(tnx4ul,firstname);
      }

      /* Now find out what/how much user sent!  Screen out files with a    *
       * .BBS or .GBS extension, to prevent trojan .BBS file uploads!      */

      for (x=0;x < fnames;x++)
        Check_Filename(ulpath,filenames[x]);

      /* Only do this if a user is on-line -- Otherwise, skip over it.     *
       * Even if user did drop carrier, we want to make sure to write      *
       * the filenames into FILES.BBS...                                   */

      if (carrier())
      {
        /* Figure out how many seconds the user was uploading for... */
        temp_long=time(NULL)-ul_start_time;

        /* Catch any divide-by-zero errors... */
        if (temp_long != 0)
        {
          /* Now factor in the upload "reward" */

          temp_long=Add_To_Time(((long)prm.ul_reward*temp_long)/100L);

          if (temp_long)
            Printf(time_added_for_ul,(long)(temp_long/60L),
                   (long)(temp_long % 60L));
        }
      }

      /* Now verify all of the files ULed, and prompt for descriptions */

      for (x=0;x < fnames;x++)
      {
        sprintf(temp,"%s%s",ulpath,filenames[x]);

        /* If we found it */

        if ((ff=FindOpen(temp,0)) != NULL)
        {
          Add_To_Upload_Log(area.uppath,ff->ff_name,ff->ff_fsize);
          Add_Upload_Bytes(ff->ff_fsize);
          Get_File_Description(ff->ff_name,ff->ff_fsize,blank_str);
        }
        else logit(cantfind,temp);

        FindClose(ff);
      }
    }
    else
    {
      Delay(50);
      logit(lxferaborted);
      Puts(xferaborted);
    }
  }

  do_timecheck=save_tc;
  Delete_OpusXfer(&xferinfo);
}



void pascal Add_Upload_Bytes(long fsize)
{
  usr.upld += (unsigned int)(fsize/1000L);
  ultoday += (unsigned int)(fsize/1000L);
  bstats.total_ul += (long)(fsize/1000L);
}

/* This file is only written during file transfers, so some other part
   of a multitasking system can tell that we're not free for a two-way
   chat, or whatever.                                                   */

void pascal Open_OpusXfer(FILE **xferinfo)
{
  char temp[PATHLEN];

  sprintf(temp,opusxfer_name,original_path,task_num);

  if ((*xferinfo=shfopen(temp,fopen_write,O_WRONLY | O_TRUNC | O_CREAT))==NULL)
    logit(cantopen,temp);
}


void pascal Close_OpusXfer(FILE **xferinfo)
{
  if (*xferinfo)
    fclose(*xferinfo);

  *xferinfo=NULL;
}


void pascal Delete_OpusXfer(FILE **xferinfo)
{
  char temp[PATHLEN];

  if (*xferinfo)
    fclose(*xferinfo);

  *xferinfo=NULL;

  sprintf(temp,opusxfer_name,original_path,task_num);
  unlink(temp);
}

void pascal File_Contents(void)
{
  char filename[PATHLEN];

  Puts(WHITE);

  WhiteN();

  OpusGets(filename,s(contents_of));

  Strip_Path(filename); /* Make sure user doesn't specify path or device */

  display_line=display_col=1;

  if (*filename)
  {
    if (! strchr(filename,'.'))
    {
      if (! fexist(filename))
        strcat(filename,s(dot_lzh));

      if (! fexist(filename))
      {
        *strrchr(filename,'.')='\0';
        strcat(filename,s(dot_arc));

        if (! fexist(filename))
        {
          *strrchr(filename,'.')='\0';
          strcat(filename,s(dot_pak));

          if (! fexist(filename))
          {
            *strrchr(filename,'.')='\0';
            strcat(filename,s(dot_zip));
          }
        }
      }
    }

    if (File_Okay(filename) && Display_Contents(filename)==-1)
    {
      if (strrchr(filename,'.'))
        *strrchr(filename,'.')='\0';

      Printf(s(bad_arc),strupr(filename));
      Press_ENTER();
    }
  }
}



int pascal Display_Contents(char *filename)
{
  struct _lhhead *lhhead;

  char buffer[SEEK_SIZE+10],
       an[PATHLEN];

  int arcfile,
      ret;

  strcpy(an,filename);

  Printf(s(sarc),strupr(an));

  if ((arcfile=shopen(an,O_RDONLY | O_BINARY))==-1)
    return -1;

  read(arcfile,buffer,SEEK_SIZE-1);
  lseek(arcfile,0L,SEEK_SET);

  lhhead=(struct _lhhead *)buffer;

  if (*buffer=='P' && *(buffer+1)=='K')
    ret=Read_Zip(arcfile);
  else if (lhhead->method[0]=='-' && lhhead->method[1]=='l' &&
          (lhhead->method[2]=='z' || lhhead->method[2]=='h') &&
           isdigit(lhhead->method[3]) && lhhead->method[4]=='-')
    ret=Read_LzhArc(ARCHIVE_lzh,arcfile);
  else if (*buffer=='\x1a')
    ret=Read_LzhArc(ARCHIVE_arc,arcfile);
  else ret=-1;

  close(arcfile);
  return ret;
}



int pascal Read_Zip(int zipfile)
{
  char buffer[SEEK_SIZE+10];
  int found_header;
  long zip_pos;

  if (lseek(zipfile,0L,SEEK_END)==-1L)
  {
    close(zipfile);
    return -1;
  }

  zip_pos=tell(zipfile);
  found_header=FALSE;

  while ((zip_pos >= 0) && (! found_header))
  {
    if (zip_pos==0)
      zip_pos=-1L;
    else zip_pos -= min((SEEK_SIZE-4L),zip_pos);

    lseek(zipfile,zip_pos,SEEK_SET);

    if (zip_pos >= 0)
    {
      if (read(zipfile,buffer,SEEK_SIZE)==-1)
        return -1;

      found_header=Zip_Scan_For_Header(buffer);
    }
  }

  if (found_header==FALSE)  /* Couldn't find central dir. header! */
    return -1;

  if (Zip_Read_Directory(zipfile,zip_pos,found_header)==-1)
    return -1;

  return 0;
}



static int near pascal Zip_Scan_For_Header(char *buffer)
{
  char *x;

  if ((x=memstr(buffer,END_STRSIG,SEEK_SIZE,strlen(END_STRSIG))) != NULL)
    return (int)(x-buffer);
  else return 0;
}



int pascal Zip_Read_Directory(int zipfile,long zip_pos,int offset)
{
  char temp[5],
       method[8],
       attributes[5],
       *filename,
       *file_comment,
       nonstop;

  long total_uncompressed,
       total_compressed;

  int num_files;

  struct _dir_end dir_end;
  struct _dir_header dir_head;
  union stamp_combo stamp;

  /* Seek to the End_Of_Central_Directory record, which we found the
     location of earlier.                                             */

  lseek(zipfile,(long)((long)zip_pos+(long)offset+4L),SEEK_SET);
  read(zipfile,(char *)&dir_end.info,sizeof(dir_end.info));

  /* We don't support multi-disk ZIPfiles */
  if (dir_end.info.this_disk != 0)
    return -1;

  nonstop=FALSE;
  display_line=display_col=1;

  /* If there is a ZIPfile comment */
  if (dir_end.info.zipfile_comment_length)
  {
    if ((file_comment=(char *)malloc(dir_end.info.zipfile_comment_length+1)) != NULL)
    {
      read(zipfile,file_comment,dir_end.info.zipfile_comment_length);
      file_comment[dir_end.info.zipfile_comment_length]='\0';

      Strip_Ansi(file_comment,0,0);

      Puts("- ");
      Puts(file_comment);
      Puts("\n\n");

      free(file_comment);
    }
    else Puts("\n\n"); /* non-critical error, continue... */
  }
  else Puts("\n\n");

  lseek(zipfile,dir_end.info.offset_start_dir,SEEK_SET);

  total_uncompressed=total_compressed=0;
  num_files=0;

  Puts(s(ziphdr1));
  Puts(s(ziphdr2));

/*     "12345678 Implode 1234567 86.0% 11-18-89 18:59 12345678 --w* ASDF.DOC"
       "                                        \n"
*/

  while (1)
  {
    read(zipfile,temp,4);

    /* If we are at a directory entry */
    if (memcmp(temp,DIR_STRSIG,4)==0)
    {
      Mdm_check();

      if (brk_trapped || mdm_halt())
      {
        brk_trapped=0;
        mdm_dump(DUMP_all);
        break;
      }

      if (MoreYnBreak(&nonstop,NULL))
        break;

      /* Read in this entry's information */
      read(zipfile,(char *)&dir_head.info,sizeof(dir_head.info));

      /* Allocate memory for filename and comments... */
      if ((filename=(char *)malloc(dir_head.info.filename_length+1))==NULL)
        return -1;

      if (dir_head.info.file_comment_length)
      {
        if ((file_comment=(char *)malloc(dir_head.info.file_comment_length+1))==NULL)
        {
          /* It isn't critical if we can't allocate the memory for the
             file comment, so just zero out the field and continue.    */

          dir_head.info.file_comment_length=0;
        }
      }

      /* Read in the filename */
      read(zipfile,filename,dir_head.info.filename_length);
      filename[dir_head.info.filename_length]='\0';

      /* Skip over the extra field */
      lseek(zipfile,(long)dir_head.info.xtra_field_length,SEEK_CUR);


      /* Read in the file comment */
      if (dir_head.info.file_comment_length)
      {
        read(zipfile,file_comment,dir_head.info.file_comment_length);
        file_comment[dir_head.info.file_comment_length]='\0';
        Strip_Ansi(file_comment,0,0);
      }

      /* Remove any funky ANSI sequences from the filename and comment */
      Strip_Ansi(filename,0,0);

      /* Figure out the compression method */
      switch (dir_head.info.comp_method)
      {
        case 0:
          strcpy(method,s(zip_store));
          break;

        case 1:
          strcpy(method,s(zip_shrunk));
          break;

        case 2:
        case 3:
        case 4:
        case 5:
          strcpy(method,s(zip_reduce));
          method[6]=(char)('0'+(dir_head.info.comp_method-1));
          break;

        case 6:
          strcpy(method,s(zip_implode));
          break;

        default:
          strcpy(method,s(unknown));
          break;
      }

      /* Grab the file's datestamp */
      stamp.dos_st.date=dir_head.info.last_mod_date;
      stamp.dos_st.time=dir_head.info.last_mod_time;

      /* Get the file's attributes */
      strcpy(attributes,four_blanks);

      attributes[3]='\0';

      /* Only get attributes for MS-DOS -- Others are implementation
         dependent.                                                   */

      if ((dir_head.info.ver_made_by >> 8)==0)
      {
        if (dir_head.info.file_attr_ext & MSDOS_hidden)
          attributes[0]='h';

        if (dir_head.info.file_attr_ext & MSDOS_system)
          attributes[1]='s';

        if (dir_head.info.file_attr_ext & MSDOS_readonly)
          attributes[2]='r';
        else attributes[2]='w';
      }

      if (!dir_head.info.uncompressed_size)
        dir_head.info.uncompressed_size=1L;

      Printf(s(zip_format),
             dir_head.info.uncompressed_size,
             method,
             dir_head.info.compressed_size,
             (int)(100-((dir_head.info.compressed_size*100)/dir_head.info.uncompressed_size)),
             (int)(1000-((dir_head.info.compressed_size*1000)/dir_head.info.uncompressed_size)) % 10,
             stamp.msg_st.date.mo,
             stamp.msg_st.date.da,
             stamp.msg_st.date.yr+80,
             stamp.msg_st.time.hh,
             stamp.msg_st.time.mm,
             dir_head.info.crc,
             attributes,
             (dir_head.info.bits & 0x01) ? '*' : ' ',
             filename);

      /* Now display the file comment... */
      if (dir_head.info.file_comment_length)
        Printf(s(zip_cmnt),file_comment);

      /* Display a warning message if file is encrypted... */
      if (dir_head.info.bits & 0x01)
        Printf(s(zip_encrypt),filename);

      /* Add this to the totals... */
      total_uncompressed += dir_head.info.uncompressed_size;
      total_compressed += dir_head.info.compressed_size;

      num_files++;

      /* Release the memory allocated for the filename, and possibly the
         file comment.                                                   */

      free(filename);

      if (dir_head.info.file_comment_length)
        free(file_comment);
    }
    else if (memcmp(temp,END_STRSIG,4)==0)
    {
      display_line += 2;

      if (MoreYnBreak(&nonstop,NULL))
        break;

      /* Found end of directory record, so we do post-processing here,
         and exit.                                                    */

       Puts(s(zip_trail1));

      if (total_uncompressed)
        Printf(s(zip_trail2),
               total_uncompressed,total_compressed,
               (int)(100-((total_compressed*100)/total_uncompressed)),
               (int)(1000-((total_compressed*1000)/total_uncompressed)) % 10,
               num_files);

      return 0;
    }
    else return -1; /* Else found gibberish! */
  }

  /* We must have gotten here by a 'N' answer to a "More [Y,n,=]?" prompt */
  return 0;
}


/* Thanks go to Andrew Farmer for the algorithm and _lhhead structure for   *
 * this routine!                                                            */

int pascal Read_LzhArc(int type,int lzhfile)
{
  struct _lhhead lhhead;
  struct _archead archead;

  char *fname,
       attr[6],
       method[10],
       nonstop;

  int crc,
      num_files;

  long total_compressed,
       total_uncompressed;

  union stamp_combo temp_date;

  num_files=0;
  total_compressed=total_uncompressed=0L;

  Puts(s(arc_h1));
  Puts(s(arc_h2));

  while (! eof(lzhfile))
  {
    Mdm_check();

    if (brk_trapped || mdm_halt())
    {
      brk_trapped=0;
      mdm_dump(DUMP_all);
      return 0;
    }

    if (MoreYnBreak(&nonstop,NULL))
      return 0;

    if (type==ARCHIVE_lzh)
    {
      read(lzhfile,(char *)&lhhead,sizeof(struct _lhhead));

      if (!lhhead.bytetotal)
        break;
    }
    else read(lzhfile,(char *)&archead,sizeof(struct _archead));

    if (!eof(lzhfile))
    {
      if (type==ARCHIVE_lzh)
      {
        if ((fname=malloc(lhhead.namelen+1))==NULL)
          return -1;

        read(lzhfile,fname,lhhead.namelen);
        fname[lhhead.namelen]='\0';

        read(lzhfile,(char *)&crc,sizeof(crc));

        strcpy(attr,four_blanks);

        if (lhhead.attr & MSDOS_archive)
          attr[0]='a';

        if (lhhead.attr & MSDOS_system)
          attr[1]='s';

        if (lhhead.attr & MSDOS_hidden)
          attr[2]='h';

        if (lhhead.attr & MSDOS_readonly)
          attr[3]='r';
        else attr[3]='w';

        /* Swap the byte order -- Probably not necessary on big-endian machines! */
        temp_date.ldate=((lhhead.date.ldate >> 16) | (lhhead.date.ldate << 16));

        strcpy(method," ");
        strncpy(method+1,lhhead.method,5);
        method[6]='\0';

        if (!lhhead.uncompressed_size)
          lhhead.uncompressed_size=1L;

        Printf(lzh_type,
             fname,
             lhhead.uncompressed_size,lhhead.compressed_size,
             (int)(100-((lhhead.compressed_size*100)/lhhead.uncompressed_size)),
             (int)(1000-((lhhead.compressed_size*1000)/lhhead.uncompressed_size)) % 10,
             temp_date.msg_st.date.mo,
             temp_date.msg_st.date.da,
             temp_date.msg_st.date.yr+80,
             temp_date.msg_st.time.hh,
             temp_date.msg_st.time.mm,
             temp_date.msg_st.time.ss << 1,
             attr,
             method,
             crc);

        free(fname);

        total_compressed += lhhead.compressed_size;
        total_uncompressed += lhhead.uncompressed_size;

        lseek(lzhfile,lhhead.compressed_size,SEEK_CUR);
      }
      else
      {
        if (archead.method >= 1 && archead.method < 11)
          strcpy(method,compression_type[archead.method]);
        else strcpy(method,compression_type[0]);

        temp_date.dos_st.date=archead.date;
        temp_date.dos_st.time=archead.time;

        if (!archead.uncompressed_size)
          archead.uncompressed_size=1L;

        Printf(lzh_type,
             archead.name,
             archead.uncompressed_size,archead.compressed_size,
             (int)(100-((archead.compressed_size*100)/archead.uncompressed_size)),
             (int)(1000-((archead.compressed_size*1000)/archead.uncompressed_size)) % 10,
             temp_date.msg_st.date.mo,
             temp_date.msg_st.date.da,
             temp_date.msg_st.date.yr+80,
             temp_date.msg_st.time.hh,
             temp_date.msg_st.time.mm,
             temp_date.msg_st.time.ss << 1,
             four_blanks,
             method,
             archead.crc);

        total_compressed += archead.compressed_size;
        total_uncompressed += archead.uncompressed_size;

        lseek(lzhfile,archead.compressed_size,SEEK_CUR);
      }

      num_files++;
    }
  }

  Puts(s(arc_t1));

  if (total_uncompressed)
      Printf(s(arc_t2),num_files,
         total_uncompressed,
         total_compressed,
         (int)(100-((total_compressed*100)/total_uncompressed)),
         (int)(1000-((total_compressed*1000)/total_uncompressed)) % 10);

  return 0;
}


void pascal File_Titles(void)
{
  char temp[BUFLEN],
       *s;

  WhiteN();

  OpusGetsLL(temp,0,s(file_title));

  if (isnl(temp) || eqstr(temp,"="))
  {
    Puts(CYAN "\n");

    if (*area.filesbbs)
      Display_File(DISPLAY_filesbbs,NULL,area.filesbbs);
    else Display_File(DISPLAY_filesbbs,NULL,ss,area.filepath,sfiles);
  }
  else if (*temp=='*')
  {
    if ((s=firstchar(temp+1,cmd_delim,1)) != NULL && isdigit(*s))
      strcpy(linebuf,s);

    if (Get_New_Date(&new_date,&laston)==-1)
      return;

    matches=0;

    if (*area.filesbbs)
      Display_File(DISPLAY_filesbbs | DISPLAY_newfiles,NULL,area.filesbbs);
    else Display_File(DISPLAY_filesbbs | DISPLAY_newfiles,NULL,ss,
                      area.filepath,sfiles);

    Printf(s(located),matches,matches==1 ? blank_str : s(pl_match));
  }
  else if (strchr(temp,'*') || strchr(temp,'?'))
    Dont_Use_Wildcards(s(ze_file_cmd));
  else
  {
    matches=0;

    Puts(CYAN "\n");
    Printf(searchingfor,fancy_str(temp),'\n');
    strcpy(searchfor,strlwr(temp));

    first_search=TRUE;

    if (*area.filesbbs)
      Display_File(DISPLAY_filesbbs | DISPLAY_search,NULL,area.filesbbs);
    else Display_File(DISPLAY_filesbbs | DISPLAY_search,NULL,ss,area.filepath,
                      sfiles);

    first_search=FALSE;

    Printf(s(located),matches,matches==1 ? blank_str : s(pl_match));
  }
}



void pascal File_Locate(void)
{
  struct _aidx aidx;

  char temp[BUFLEN],
       *s,
       nonstop;

  long aidxoff;

  int savearea,
      sf,
      x,y;

  savearea=usr.files;

  if (isnl(linebuf))
    Puts(s(loc_banner));

  while (1)
  {
    if (isnl(linebuf))
      Puts(s(note_helpnf));

    OpusGetsLL(temp,BUFLEN,s(loc_file));

    if (eqstr(temp,qmark))
      Display_File(0,NULL,PRM(hlp_locate));
    else if (! isnl(temp))
    {
      if (((s=strchr(temp,'*')) != NULL && s != temp) || strchr(temp,'?'))
        Dont_Use_Wildcards(s(ze_loc_cmd));
      else
      {
        nonstop=FALSE;
        matches=0;

        if (*temp=='*')
        {
          WhiteN();

          if ((s=firstchar(temp+1,cmd_delim,1)) != NULL && isdigit(*s))
            strcpy(linebuf,s);

          if (Get_New_Date(&new_date,&laston)==-1)
            return;

          display_line=display_col=1;
        }
        else
        {
          display_line=display_col=1;
          Printf(searchingfor,fancy_str(temp),'\0');
        }

        lseek(areasidx,aidxoff=0L,SEEK_SET);

        sf=TRUE;

        while (read(areasidx,(char *)&aidx,sizeof(struct _aidx))==sizeof(struct _aidx))
        {
          Mdm_check();

          if (brk_trapped || mdm_halt())
          {
            brk_trapped=0;
            mdm_dump(DUMP_all);
            break;
          }

          barricade_ok=FALSE;

          if (IsValidFileArea(NULL,aidx.area) && ExtBarricadeOK(&area,FALSE,NULL) &&
              aidx.area <= prm.high_filearea)
          {
            usr.files=aidx.area;

            if (Save_Directory(area.filepath)==-1)
            {
              logit(mem_ndir);
              Puts(mem_ndir);
              break;
            }

            x=DISPLAY_filesbbs;

            strcpy(searchfor,strlwr(temp));

            if (sf)
            {
              first_search=TRUE;
              sf=FALSE;
            }

            Printf(attr_string,(aidx.area % 7)+9);
            Printf(s(srchng),Area_Name(aidx.area));

            x |= DISPLAY_areaname;

            if (*searchfor=='*')
              x |= DISPLAY_newfiles;
            else x |= DISPLAY_search;

            if (*area.filesbbs)
              y=Display_File(x,&nonstop,area.filesbbs);
            else y=Display_File(x,&nonstop,ss,area.filepath,sfiles);

            first_search=FALSE;

            if (y==-2 || y==-3)  /* If "More [Y,n,=]?" was answered 'N' or ^C'd */
              break;
          }

          lseek(areasidx,aidxoff += sizeof(struct _aidx),SEEK_SET);
        }

        Puts(space_over);

        Printf(s(located),matches,matches==1 ? blank_str : pl_match);
        break;
      }
    }
    else break;
  }

  /* Restore original area */
  IsValidFileArea(NULL,usr.files=savearea);
}

void pascal Check_Filename(char *ulpath,char *fname)
{
  char *p;

  char temp[PATHLEN],
       temp2[PATHLEN];

   
  if (! GEPriv(usr.priv,prm.ulbbs_priv) &&
      ((p=stristr(fname,dotbbs)) != NULL ||
       (p=stristr(fname,dotgbs)) != NULL))
  {
    /* Save the original filename... */
    sprintf(temp,"%s%s",ulpath,fname);

    /* Change *(p+3) (the 's' of ".bbs") to an 'x' */

    *(p+3)='X';

    /* Copy this name into temp2, with the required path */

    sprintf(temp2,ss,ulpath,fname);

    /* Increment the extension until no more dupes */

    unique_name(temp2);

    /* Actually do the rename call... */

    move_file(temp,temp2);

    /* And we're done! */
    logit(s(ul_renamed),temp,temp2);
  }
}


#include "isvfa.c"


